      MODULE LA_XTGEX2
!
!  -- LAPACK 3E module --
!     E. Anderson
!     June 07, 2002
!
!  Purpose
!  =======
!
!  LA_XTGEX2 defines generic interfaces for xTGEX2.
!
      INTERFACE LA_TGEX2

      SUBROUTINE STGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, J1, N1, N2, WORK, LWORK, INFO )
         USE LA_CONSTANTS32, ONLY: WP
         LOGICAL, INTENT(IN) :: WANTQ, WANTZ
         INTEGER, INTENT(IN) :: J1, LDA, LDB, LDQ, LDZ, LWORK, N, N1, N2
         INTEGER, INTENT(OUT) :: INFO
         REAL(WP), INTENT(INOUT) :: A(LDA,*), B(LDB,*), Q(LDQ,*),
     $                              Z(LDZ,*)
         REAL(WP), INTENT(OUT) :: WORK(*)
      END SUBROUTINE STGEX2

      SUBROUTINE DTGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, J1, N1, N2, WORK, LWORK, INFO )
         USE LA_CONSTANTS, ONLY: WP
         LOGICAL, INTENT(IN) :: WANTQ, WANTZ
         INTEGER, INTENT(IN) :: J1, LDA, LDB, LDQ, LDZ, LWORK, N, N1, N2
         INTEGER, INTENT(OUT) :: INFO
         REAL(WP), INTENT(INOUT) :: A(LDA,*), B(LDB,*), Q(LDQ,*),
     $                              Z(LDZ,*)
         REAL(WP), INTENT(OUT) :: WORK(*)
      END SUBROUTINE DTGEX2

      SUBROUTINE CTGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, J1, INFO )
         USE LA_CONSTANTS32, ONLY: WP
         LOGICAL, INTENT(IN) :: WANTQ, WANTZ
         INTEGER, INTENT(IN) :: J1, LDA, LDB, LDQ, LDZ, N
         INTEGER, INTENT(OUT) :: INFO
         COMPLEX(WP), INTENT(INOUT) :: A(LDA,*), B(LDB,*), Q(LDQ,*),
     $                                 Z(LDZ,*)
      END SUBROUTINE CTGEX2

      SUBROUTINE ZTGEX2( WANTQ, WANTZ, N, A, LDA, B, LDB, Q, LDQ, Z,
     $                   LDZ, J1, INFO )
         USE LA_CONSTANTS, ONLY: WP
         LOGICAL, INTENT(IN) :: WANTQ, WANTZ
         INTEGER, INTENT(IN) :: J1, LDA, LDB, LDQ, LDZ, N
         INTEGER, INTENT(OUT) :: INFO
         COMPLEX(WP), INTENT(INOUT) :: A(LDA,*), B(LDB,*), Q(LDQ,*),
     $                                 Z(LDZ,*)
      END SUBROUTINE ZTGEX2

      END INTERFACE ! LA_TGEX2

      END MODULE LA_XTGEX2
